package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.dto.scale.NewResultDto;
import com.rf.psychological.scale.scaleresult.ScaleConstant;
import com.rf.psychological.utils.Constant;

import java.util.*;

/**
 * @description 心理测试：你应对职场动荡的能力
 */
public class DWTAScale extends BaseScale {
    public DWTAScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*ScaleUtil.getScaleDll("DWTASCALE.dll");
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("resultJson:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.DWTAScale(jsonArray.toString(), resultJson.toString());
        //System.out.println("dllresult:"+result);
        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObject:"+jsonObject);
        return jsonObject;*/

        //A总分
        int scoreA = 0;
        //B总分
        int scoreB = 0;

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if ((i + 1) % 2 != 0) {
                if (jsonObject1.getString("checkItems").equals("是")) {
                    scoreA += 2;
                } else if (jsonObject1.getString("checkItems").equals("否")) {
                    scoreA += 0;
                }
            } else {
                if (jsonObject1.getString("checkItems").equals("是")) {
                    scoreB += 2;
                } else if (jsonObject1.getString("checkItems").equals("否")) {
                    scoreB += 0;
                }
            }
        }

        Map<String,Double> dimensionScoreMap = new HashMap<>();
        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("A总分", String.valueOf(scoreA));
        resultMap.put("B总分", String.valueOf(scoreB));
        resultJson.put("A总分", String.valueOf(scoreA));
        resultJson.put("B总分", String.valueOf(scoreB));

        dimensionScoreMap.put("8af178857b94d581017b9500f4ab25bc", (double) scoreA);
        dimensionScoreMap.put("8af178857b94d581017b9500f50125bd", (double) scoreB);
        resultJson.put("dimensionScoreMap",dimensionScoreMap);

        if (scoreA > 5 && scoreB > 5) {
            resultMap.put("结论", "恭喜你，成长对于你基本取决于行动。");
            resultJson.put("结论", "恭喜你，成长对于你基本取决于行动。");
        } else if (scoreA > 5 && scoreB < 5) {
            resultMap.put("结论", "你属于干着急型，能看到很多变化，但没有足够的应变能力。");
            resultJson.put("结论", "你属于干着急型，能看到很多变化，但没有足够的应变能力。");
        } else if (scoreA < 5 && scoreB > 5) {
            resultMap.put("结论", "你应变力不错，但敏锐度不足，所以无法实现主动成长，但生存没有问题，因为你适应力强。");
            resultJson.put("结论", "你应变力不错，但敏锐度不足，所以无法实现主动成长，但生存没有问题，因为你适应力强。");
        } else if (scoreA < 5 && scoreB < 5) {
            resultMap.put("结论", "你随时都会有职业危机，因此，你必须行动起来了。");
            resultJson.put("结论", "你随时都会有职业危机，因此，你必须行动起来了。");
        }

        List<Map<String, String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_DWTA);
        returnJson.put("resultJson", resultJson);

        return returnJson;
    }

    public JSONObject scaleCalculateV2() throws Exception {

        //A总分
        int scoreA = 0;
        //B总分
        int scoreB = 0;

        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if ((i + 1) % 2 != 0) {
                if (jsonObject1.getString("checkItems").equals("是")) {
                    scoreA += 2;
                } else if (jsonObject1.getString("checkItems").equals("否")) {
                    scoreA += 0;
                }
            } else {
                if (jsonObject1.getString("checkItems").equals("是")) {
                    scoreB += 2;
                } else if (jsonObject1.getString("checkItems").equals("否")) {
                    scoreB += 0;
                }
            }
        }


        //得分列表
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("A总分", String.valueOf(scoreA));
        resultMap.put("B总分", String.valueOf(scoreB));
        resultJson.put("A总分", String.valueOf(scoreA));
        resultJson.put("B总分", String.valueOf(scoreB));
        Map<String,Double> dimensionScoreMap = new HashMap<>();
        dimensionScoreMap.put("8af178857b94d581017b9500f4ab25bc", (double) scoreA);
        dimensionScoreMap.put("8af178857b94d581017b9500f50125bd", (double) scoreB);
        resultJson.put("dimensionScoreMap",dimensionScoreMap);
        //新版本数据格式
        Map<String, Object> newResult = new LinkedHashMap<>();
        //返回值以及存数据库格式
        List<NewResultDto> newResultDtos = new ArrayList<>();
        newResultDtos.add(new NewResultDto("敏锐度分数A", String.valueOf(scoreA), "无", "无", "无",
                "无", "无", "无", "否"));
        newResultDtos.add(new NewResultDto("应变力分数B", String.valueOf(scoreB), "无", "无", "无",
                "无", "无", "无", "否"));
        if (scoreA > 5 && scoreB > 5) {
            resultMap.put("结论", "恭喜你，成长对于你基本取决于行动。");
            newResultDtos.add(new NewResultDto("总分", String.valueOf(scoreA + scoreB), "行动型", "恭喜你，成长对于你基本取决于行动。 ", "无",
                    "无", "无", "无", "是"));
            resultJson.put("结论", "恭喜你，成长对于你基本取决于行动。");
        } else if (scoreA > 5 && scoreB < 5) {
            resultMap.put("结论", "你属于干着急型，能看到很多变化，但没有足够的应变能力。");
            newResultDtos.add(new NewResultDto("总分", String.valueOf(scoreA + scoreB), "干着急型", "你属于干着急型，能看到很多变化，但没有足够的应变能力。", "无",
                    "无", "无", "无", "是"));
            resultJson.put("结论", "你属于干着急型，能看到很多变化，但没有足够的应变能力。");
        } else if (scoreA < 5 && scoreB > 5) {
            resultMap.put("结论", "你应变力不错，但敏锐度不足，所以无法实现主动成长，但生存没有问题，因为你适应力强。");
            newResultDtos.add(new NewResultDto("总分", String.valueOf(scoreA + scoreB), "随机应变型", "你应变力不错，但敏锐度不足，所以无法实现主动成长，但生存没有问题，因为你适应力强。 ", "无",
                    "无", "无", "无", "是"));
            resultJson.put("结论", "你应变力不错，但敏锐度不足，所以无法实现主动成长，但生存没有问题，因为你适应力强。");
        } else if (scoreA < 5 && scoreB < 5) {
            resultMap.put("结论", "你随时都会有职业危机，因此，你必须行动起来了。");
            newResultDtos.add(new NewResultDto("总分", String.valueOf(scoreA + scoreB), "危机型", "你随时都会有职业危机，因此，你必须行动起来了。", "无",
                    "无", "无", "无", "是"));
            resultJson.put("结论", "你随时都会有职业危机，因此，你必须行动起来了。");
        }
        newResult.put("iconInfo", "");
        newResult.put("result", newResultDtos);
        List<Map<String, String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        returnJson.put("scaleName", Constant.SHEET_NAME_DWTA);
        returnJson.put("resultJson", resultJson);
        returnJson.put(ScaleConstant.ResultEnum.RESULT_NEW_FIELD.getKeyword(), newResult);

        return returnJson;
    }
}
